class vcDragCloseButton extends HTMLElement
{
  constructor() 
  { super();
    this.HasBeenConnected = false;
    this.Closed = false;
    this.DragSingle = new vcDragSingle();
	  if (vcDragSingle.OnCreateDrag) return;
    this.addEventListener('click',this._onClick.bind(this));
    this.addEventListener('keyup',this._onKeyup.bind(this));
  }
  
 connectedCallback() 
  { this.HasBeenConnected = true; 
    var sw = this.firstElementChild;
//    if (this.Closed==false) 
      if (sw!=null) console.log("Switch attribute = " + sw.getAttribute("transform"));
  } 
   
   
//PUBLIC METHODS
   
  Close(DoClose)
  { if (DoClose==this.Closed) return;
    this._doClick();
  }
  
  GetState(DoClose)
  { return this.Closed;
  }
  
  

  
//HTMLElement events :
  
  _onClick(ev)
  { ev.preventDefault();
    ev.stopPropagation();
    this._doClick();
  }
  
  _onKeyup(ev)
  { if (ev.which==32)
    { this._doClick();
      ev.stopPropagation();
    }
  }
  

  
//PRIVATE FUNCTIONS
 
  _doClick()
  { var el = this.parentNode; 
    do
    { if (el==null) return;
      if (el.nodeName=="VC-DRAGITEM") break;
      el = el.parentNode;
    } while (true);
    el = el.firstElementChild;
    do 
    { if (el==null) return;
      if (el.nodeName=="VC-DRAGCONTAINER") break;
      el = el.nextElementSibling;
    } while (true);
    var sw = this.firstElementChild;
    if (this.Closed)
    { this.Closed = false; 
      el.style.maxHeight = "none";
      if (sw!=null) sw.setAttribute("transform", "rotate(0)");
    }
    else
    { this.Closed = true;
      el.style.maxHeight = "0px";
      if (sw!=null) sw.setAttribute("transform", "rotate(180)");
    } 
  }
}      
      
customElements.define('vc-dragclosebutton',vcDragCloseButton);