class vcDragDeleteButton extends HTMLElement
{
  constructor() 
  { super();
    this.HasBeenConnected = false;
    this.DragSingle = new vcDragSingle();
	  if (vcDragSingle.OnCreateDrag) return;
    this.addEventListener('click',this._onClick.bind(this));
    this.addEventListener('keyup',this._onKeyup.bind(this));
  }

 connectedCallback() 
  { this.HasBeenConnected = true; 
  } 
  
  
  
//Methods inherited from HTMLElement :
  
  setAttribute(name,value)
  { super.setAttribute(name,value);
    if (name.startsWith("vc-"))
    { var str = name.slice(3);
    }
  }
  
  

  
//HTMLElement events :
  
  _onClick(ev)
  { ev.preventDefault();
    ev.stopPropagation();
    this._doClick();
  }
  
  _onKeyup(ev)
  { if (ev.which==32)
    { this._doClick();
      ev.stopPropagation();
    }
  }
  

  
//PRIVATE FUNCTIONS
 
  _doClick()
  { 
    var el = this.parentNode;
    do
    { if (el==null) return;
      if (el.nodeName=="VC-DRAGITEM") break;
      el = el.parentNode;
    } while (true);
    this.DragSingle.DeleteDragItem(el); 
    
  }
}      
      
customElements.define('vc-dragdeletebutton',vcDragDeleteButton);